'
'	"DisAsm.bas"

' A disassembler for PowerBASIC-compiled
'EXEs and DLLs. It might not work with files
'compiled with other compilers because some
'have different section-naming conventions.

'Public domain by TheirWare Corporation 2004
'

'It now only uses 5 globals, when not in debug
'mode :)

'
'This version generates:
'1) Disassembly of code
'2) Dump of data
'3) Listing of imports
'4) Listing of exports

'It doesn't handle resources nor relocations
'yet. The output format will be changed to be
'compatible with Fasm and perhaps some other
'assemblers. For now, it merely display it all.

'
'This will often generate an extra "between-
'procedure" line of code, just before the entry
'point due to the way it synchronizes with the
'entry point. This is harmless.


'
'The procedure entry points are slightly obscured
'by code which appears between all user-written
'procedures in PowerBASIC Win32 programs. They

'Here's the sequence of opcodes and instructions to
'ignore:
'0000				   ADD BYTE PTR [EAX], AL
'0000				   ADD BYTE PTR [EAX], AL
'0000				   ADD BYTE PTR [EAX], AL
'007062 			   ADD BYTE PTR [EAX+62], DH

'Look just beyond this series for:
'55 				   PUSH EBP
'...that will be the entry point

'
#Compile Exe "DisAsm.exe"
#Dim All

'

#Include "WINCLEAN.INC"
#Include "PBForms.INC"

#Include "PE.inc"		'PE UDTs
#Include "Decs.inc" 	'variables
#Include "Settings.inc"
#Include "DisAsm.inc"	'the disassembler code
#Include "PeEdit.inc"	'code to get PE information
#Include "Analyse.inc"	'code analyzer

'

Declare CallBack Function ShowDlgProc()
Declare Function SampleListBox(ByVal hDlg As Dword, ByVal lID As Long, ByVal lCount As Long) As Long
Declare Function ShowDlg(ByVal hParent As Dword) As Long

'

Function PBMain()
	ShowDlg %HWND_DESKTOP
End Function

'
'returns %true, if any files were received
Function GetDroppedFile(ByVal hDrop As Long, fs As String) As Long
Local ct  As Dword
Local az  As Asciiz * %MAX_PATH

	ct = DragQueryFile(hDrop, &HFFFFFFFF&, "", ByVal 0&)

	If ct > 0 Then
		az = Space$(%MAX_PATH)
		ct = DragQueryFile(hDrop, 0, az, Len(az) - 1)
		fs = Left$(az, ct)
		Function = %True
	End If

End Function

'
'expects "fs" to contain the path and name
'of an PE format file.
Function CallDisAsm(fs As String) As Long
Local r 	As Long

	Dialog Set Text hDlg, $Caption & " - Working..."

	GetSettings hDlg

	If Len(fs) Then
		If GetPeInfo(fs) = 0 Then AnalyseCode()
	Else
		Dialog Set Text hDlg, $Caption & " - Bad file name"
	End If

	Dialog Set Text hDlg, $Caption & IIf$(r, " - Error", " - Ready...")

	Function = r

End Function 'CallDisAsm

'

CallBack Function ShowDlgProc()
Static pt	As String
Local  fs	As String

	Select Case As Long CbMsg

		Case %WM_INITDIALOG
			pt = CurDir$
			LoadSettings hDlg

		Case %WM_DESTROY
			ChDir pt
			SaveSettings hDlg

		Case %WM_NCACTIVATE
			Static hWndSaveFocus  As Dword
			If IsFalse CbWParam Then
				hWndSaveFocus = GetFocus()
			ElseIf hWndSaveFocus Then
				SetFocus(hWndSaveFocus)
				hWndSaveFocus = 0
			End If

		Case %WM_DROPFILES
			If (GetDroppedFile(CbWParam, fs)) Then
				Control Set Text hDlg, %PathTxt, fs
				CallDisAsm(fs)
			End If
			DragFinish CbWParam

		Case %WM_COMMAND

			Select Case As Long CbCtl
				Case %DisBtn
					If CbCtlMsg = %BN_CLICKED Or CbCtlMsg = 1 Then
						Control Get Text hDlg, %PathTxt To fs
						CallDisAsm(fs)
					End If

			End Select

	End Select

End Function

'

Function ShowDlg(ByVal hParent As Dword) As Long
	Local lRslt  As Long
	Local hFont1 As Dword

	Dialog New	hParent, "DisAsm", , , 234, 63, %WS_POPUP Or %WS_BORDER Or _
		%WS_DLGFRAME Or %WS_CAPTION Or %WS_SYSMENU Or %WS_MINIMIZEBOX Or %WS_CLIPSIBLINGS Or _
		%WS_VISIBLE Or %DS_MODALFRAME Or %DS_3DLOOK Or %DS_NOFAILCREATE Or %DS_SETFONT, _
		%WS_EX_CONTROLPARENT Or %WS_EX_TOOLWINDOW Or %WS_EX_LEFT Or %WS_EX_LTRREADING Or _
		%WS_EX_RIGHTSCROLLBAR Or %WS_EX_ACCEPTFILES, To hDlg
	Control Add Label,	  hDlg, %FileLbl, "File", 1, 1, 132, 10, %WS_CHILD Or %WS_VISIBLE Or _
		%SS_CENTER, %WS_EX_LEFT Or %WS_EX_LTRREADING
	Control Add TextBox,  hDlg, %PathTxt, "", 1, 11, 132, 12
	Control Add CheckBox, hDlg, %AddrChk, "Include addresses", 144, 8, 84, 10
	Control Add CheckBox, hDlg, %OpcodeChk, "Include opcodes", 144, 18, 84, 10
	Control Add CheckBox, hDlg, %MnemChk, "Include mnemonics", 144, 28, 84, 10
	Control Add Button,   hDlg, %DisBtn, "&DisAssemble", 5, 43, 48, 14, %WS_CHILD Or %WS_VISIBLE _
		Or %WS_BORDER Or %WS_TABSTOP Or %BS_TEXT Or %BS_PUSHBUTTON Or %BS_CENTER Or %BS_VCENTER, _
		%WS_EX_LEFT Or %WS_EX_LTRREADING
	Control Add Frame,	  hDlg, %OptFrm, "Options", 140, 0, 92, 40, %WS_CHILD Or %WS_VISIBLE Or _
		%BS_TEXT Or %BS_CENTER Or %BS_TOP Or %BS_GROUPBOX, %WS_EX_LEFT Or %WS_EX_LTRREADING

	hFont1 = PBFormsMakeFont("MS Sans Serif", 8, 700, %FALSE, %FALSE, %FALSE, %ANSI_CHARSET)
	Control Send hDlg, %OptFrm, %WM_SETFONT, hFont1, 0
	Control Send hDlg, %FileLbl, %WM_SETFONT, hFont1, 0

	DragAcceptFiles hDlg, %True 'Register window to accept dropped files.

	Dialog Show Modal hDlg, Call ShowDlgProc To lRslt

	DeleteObject hFont1

	Function = lRslt

End Function

'
