'<O><O><O><O><O><O><O><O><O><O><O><O><O><O><O><O>


'<O><O><O><O><O><O><O><O><O><O><O><O><O><O><O><O>
'Returns the number of extra bytes in string
'Returns a string containing one decoded instruction
'wf = instruction bytes
Function DisAsm1( wf As String) As String

#Register None

Local ba    As Dword    'base address
Local pd    As Dword
Local pe    As Dword    'pointer to end of code

Local b     As Long     'byte number for hex dump
Local dp    As Byte     '"divide procedure" flag
Local ip    As Dword    '"instruction pointer"
Local cb1   As Byte     'opcode byte 1
Local cb2   As Byte     'opcode byte 2
Local cb3   As Byte     'opcode byte 3
Local pc    As Byte     'prefix count

Local fa    As Word     'flag array
Local oz    As Byte     'operand size override flag
Local az    As Byte     'address size override flag
Local wr    As Byte     'word bit indicator
Local tt    As Byte     'condition type 0-15

Local md    As Byte     '"mod" field
Local rm    As Byte     'r/m field
Local rr    As Byte     'register field

Local de    As Byte     'destination register or r/m
Local sr    As Byte     'source register or r/m
Local dt    As Byte     'type of destination contents
Local st    As Byte     'type of source contents
Local t3    As Byte     'type of third operand
Local o3    As Byte     'third operand

'   SIB variables
Local sf    As Byte     'scale factor
Local ir    As Byte     'index register
Local br    As Byte     'base register

Local h    As Dword     'miscellaneoous hex values
Local n    As Long
Local p    As Long

'   miscellaneous
Local d    As String   'hex dump of instruction
Local mn   As String

Local ad   As String   'address

Local os   As String   'operand size indicator
Local pr   As String   'prefixes
Local pf   As Long     'prefix flag

Local db    As Long     'for debugging this disassembler

#If %Def(%Debug)
	EscBits = $EscBits
	PrefixBits = $PrefixBits
	NormBits = $NormBits

	GoTo PastBitFields
#Else

!'ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
	' ***  The Bit-Fields ***
!'ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo

	GoTo PastBitFields

	!'These can't be used if running PB's debugger, so equivalent strings are
	!'used instead (by defining %Debug)

	EscBits:
	'0F  C0  C1  D0  D1  D2  D3  D8  D9  DA  DB  DC  DD  DE  DF  F2  F3
	! db 0,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,0,15,255,0,0,12,0

	PrefixBits:
	'26 2E  36  3E  64  65  66  67  9B  F0  F2  F3
	'ES: CS: SS: DS: FS: GS: OpSize: AddrSize: FWAIT: LOCK: REPNE: REP/REPE:
	! db 0,0,0,0,64,64,64,64,0,0,0,0,240,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,13,0

	NormBits: 'these opcodes follow an encoding pattern
	'00 01 02 03 04 05 08 09 0A 0B 0C 0D 10 11 12 13 14 15 18 19 1A 1B 1C 1D 20 21
	'22 23 24 25 28 29 2A 2B 2C 2D 30 31 32 33 34 35 38 39 3A 3B 3C 3D
	'ADD     ADC     AND     CMP   OR   SBB     SUB     XOR
	! db 63,63,63,63,63,63,63,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0

#EndIf

!'ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
' ***  Some Local Subs  ***
!'ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo

	'ooooooooooooooooooooooooooooooooooooo

PrintAd: 'collect target addresses
	'Print# ft, ad   'Print# ft, Right$(ad, 6)
Return

	'ooooooooooooooooooooooooooooooooooooo

'$R8And32    = "ALCLDLBLAHCHDHBHAXCXDXBXSPBPSIDI"
DecodeReg:

	If wr Then          '16 or 32-bit register
		de = de + 8
		If az = 0 Then mn = mn & "E"    '32-bit register
	End If

	mn = mn & Mid$($R8And32, (de * 2) + 1, 2)

Return

	'ooooooooooooooooooooooooooooooooooooo

'$Regs       = "AXCXDXBXSPBPSIDI"
DecodeReg32:

	mn = mn & IIf$(az, "", "E") & Mid$($Regs, (de * 2) + 1, 2)

Return

	'ooooooooooooooooooooooooooooooooooooo

DecodeRel8:

	cb3 = Asc(wf, ip + n)
	If (cb3 And &H80) Then
		mn = mn & "-"
		cb3 = (Not cb3) + 1
	Else
		mn = mn & "+"
	End If
	mn = mn & Hex$(cb3, 2)
	Incr n

Return

	'ooooooooooooooooooooooooooooooooooooo

DecodeDisp32: '(16-bit displacements also)

	mn = mn & Hex$(CvDwd(wf, ip + n), IIf&(az, 4, 8))
	n = n + IIf&(az, 2, 4)

Return

	'ooooooooooooooooooooooooooooooooooooo
'   TD32 format for instruction with SIB:
'   8A A4 84 5C 02 00 00  mov ah, [esp+4*eax+0000025C]
DecodeSib:

	sf = Asc(wf, ip + n)
	ir = (sf\8) And 7       'get index register
	br = sf And 7           'get base register
	sf = 2 ^ ((sf\64) And 3) 'compute scale factor

	If (md = 0) And (br = 5) Then
		GoSub DecodeDisp32
	Else
		de = br : GoSub DecodeReg32
	End If

	If ir <> 4 Then     'index register is used
		mn = mn & "+" & IIf$(sf > 1, Format$(sf) & "*", "")
		de = ir : GoSub DecodeReg32
	End If
	Incr n

Return

	'ooooooooooooooooooooooooooooooooooooo

DecodeRegMem:

	Incr n
	If md <> 3 Then
		If Len(os) = 0 Then
			If wr Then
				If oz = 0 Then os = "D
				os = os & "WORD"
			Else
				os = "BYTE"
			End If
		End If
		mn = mn & os & " PTR ["
	End If

	Select Case As Long md

		Case 0 'MOD = disp32 or [reg] with no displacement

			If de = 4 Then 'SIB with no displacement
				GoSub DecodeSib
			ElseIf de = 5 Then '32-bit displacement
				GoSub DecodeDisp32
			Else 'de = 0 through 3, or 6 through 7
				GoSub DecodeReg32
			End If 'de = 4

		Case 1 'MOD = relative [reg + disp8]
			If de = 4 Then 'SIB + relative disp8
				GoSub DecodeSib
			Else 'de = 0 through 3, or 5 through 7
				GoSub DecodeReg32
			End If 'de = 4

			GoSub DecodeRel8

		Case 2 'MOD = absolute [reg + disp32]
			If de = 4 Then 'SIB + disp32
				GoSub DecodeSib
				mn = mn & "+"
			Else 'de = 0 through 3, or 5 through 7
				GoSub DecodeReg32
				mn = mn & "+"

			End If 'de = 4

			GoSub DecodeDisp32

		Case 3 'MOD = reg
			GoSub DecodeReg

	End Select

	If md <> 3 Then mn = mn & "]"

	Return 'DecodeRegMem

	'ooooooooooooooooooooooooooooooooooooo

!'ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
	' ***  End of Local Subs  ***
!'ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo


' ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo


!'ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
	' ***  The Main Code  ***
!'ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo

	PastBitFields:

	ip = 1      'pointer to next byte in opcode string
	pe = Len(wf)

	Do
		If pf Then

			'If Bit(Prefs, 0) Then 'show addresses
			'    d = Hex$(ba + ip - pd - pc, 6) & $Tab
			'End If

			'If Bit(Prefs, 1) Then 'show opcodes
			'    For b = 0 To n + pc - 1
			'        d = d & Hex$(Asc(wf, ip + b - pc), 2) '& " "
			'    Next b
			'    d = d & Space$(30 - Len(d))
			'End If

			Function = pr & mn  'Print #fo, d & IIf$(Bit(Prefs, 2), pr & mn, "")
			Exit Do

			'If dp Then  'divide procedures
			'    Print# fo, ""
			'    Print# fo, "'" & String$(40, "*")
			'    Print# fo, ""
			'    dp = 0
			'End If

			os = "" : pr = "" : pc = 0 : d = ""
		End If

		pf = 1
		ip = ip + n : n = 0

		'this should synchronize ip with ep (the entry point)
		'ep is set to Len(wf) at next print, so this won't repeat
		'If ip > ep Then ip = ep

		cb1 = Asc(wf, ip + n)
		Incr n
		cb2 = Asc(wf, ip + n)

		md = (cb2\64) : rm = cb2 And 7 : rr = (cb2\8) And 7
		fa = 0 : wr = 0 : dt = %Implied : st = %Implied


	!'ooooooooooooooooooooooooooooooooo
	'  Escape Code Filter
	!'ooooooooooooooooooooooooooooooooo

	'0F                         general and SIMD
	'C0 C1 D0 D1 D2 D3          shift and rotate
	'D8 D9 DA DB DC DD DE DF    FPU
	'F2 F3                      Repeat and some SIMD
	'----------------------------------
	'  binary equivalents of escape codes

	'0F = 0000 1111
	'-------------
	'C0 = 1100 0000
	'C1 = 1100 0001
	'D0 = 1101 0000
	'D1 = 1101 0001
	'D2 = 1101 0010
	'D3 = 1101 0011
	'-------------
	'D8 = 1101 1000
	'D9 = 1101 1001
	'DA = 1101 1010
	'DB = 1101 1011
	'DC = 1101 1100
	'DD = 1101 1101
	'DE = 1101 1110
	'DF = 1101 1111
	'-------------
	'F2 = 1111 0010
	'F3 = 1111 0011
	'----------------------------------
	! movzx eax, cb1
	! bt EscBits, eax
	! mov cb3, 0
	! adc cb3, 0        ;cb3 is handy
	If cb3 = 0 Then GoTo NoEscBit
	Select Case cb1
		Case &H0F
			GoTo Esc0F
		Case &HC0 To &HD3
			GoTo EscShift
		Case &HD8 To &HDF
			GoTo EscFpu
		Case Else 'must be F2 or F3
			GoTo PrefixHandler
	End Select

'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
'the old code
'    ! movzx eax, cb1
'    ! bt EscBits, eax
'    ! jnc NoEscBit
'    ! mov ah, al
'    ! and ah, &H98      '&H98 = 1001 1000
'    ! cmp ah, &H18
'    ! je EscFpu
'    ! jns Esc0F
'    ! test al, &H20     '&H20 = 0010 0000
'    ! je EscShift       'bit shift and rotate
'    ! jmp PrefixHandler

	'----------------------------------

	!'ooooooooooooooooooooooooooooooooo
	'  FPU Opcodes
	!'ooooooooooooooooooooooooooooooooo
	'do the FPU instructions D8 D9 DA DB DC DD DE DF        ! sub al, &H0D8
	'D8 = 11011000
	'D9 = 11011001
	'DA = 11011010
	'DB = 11011011
	'DC = 11011100
	'DD = 11011101
	'DE = 11011110
	'DF = 11011111
EscFpu:
wr = 1
#Include "E:\PBWin7\Asm\DisAsm\DisAsm\FPU.inc"

	GoTo OpcodeDone

	!'ooooooooooooooooooooooooooooooooo
	'  0F Escaped Codes
	!'ooooooooooooooooooooooooooooooooo
Esc0F:
	Incr n
	If (cb2 => &H80) And (cb2 <= &H8F) Then
		mn = "J"
		tt = cb2 And 15
		fa = %Condition
		dt = %Rel32

	ElseIf (cb2 <= &H9F) Then
		mn = "SET"
		tt = cb2 And 15
		fa = %Condition
		dt = %RegMem

	Else

#Include "E:\PBWin7\Asm\DisAsm\DisAsm\Esc0F.inc"

	End If

	GoTo OpcodeDone


	!'ooooooooooooooooooooooooooooooooo
	'  Shift and Rotate Escape Codes
	!'ooooooooooooooooooooooooooooooooo
	'C0 = 11000000
	'C1 = 11000001
	'D0 = 11010000
	'D1 = 11010001
	'D2 = 11010010
	'D3 = 11010011
	'-------------
EscShift:
		' C0 r/m8,imm8  C1 r/m16,imm8
		' D0 r/m8,1     D1 r/m16,1      D2 r/m8,CL      D3 r/m16,CL
		mn = Mid$("ROLRORRCLRCRSHLSHR???SAR", ((((cb2\8) And 7) * 3) + 1), 3)
		dt = %RegMem : de = rm
		Select Case As Long cb1 And &HFE
			Case &HC0
				st = %Imm8
			Case &HD0
				st = %ByOne
			Case &HD2
				st = %ByCL
		End Select
		wr = (cb1 And 1)

	GoTo OpcodeDone

!'ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
'   End of Escape Code Handlers
!'ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo

	!'ooooooooooooooooooooooooooooooooo
	'  Non-Escaped Instructions
	!'ooooooooooooooooooooooooooooooooo

NoEscBit:
	! movzx eax, cb1
	! bt NormBits, eax
	! jnc NoNormBit


	!'ooooooooooooooooooooooooooooooooo
	'  "Normal" Instructions
	!'ooooooooooooooooooooooooooooooooo

	'$Mn80       = "ADDOR ADCSBBANDSUBXORCMP"

	'NormHandler:
	! mov byte ptr fa, al
	! and byte ptr fa, 7
	mn = Mid$($Mn80, (((cb1\8) And 7) * 3) + 1, 3)
	st = %RegMem : sr = rm
	dt = %Reg : de = rr
	wr = (cb1 And 1)

	If (cb1 And 6) = 4 Then 'immediate to AL/AX/EAX
		st = %Imm8_32 : de = 0
	Else
		If (cb1 And 2) = 0 Then Swap st, dt : Swap sr, de
	End If

	GoTo OpcodeDone

NoNormBit: 'opcode doesn't conform to the pattern

	'is it a conditional short jump?
	! mov al, cb1
	! sub al, &H70
	! jb NotNearJcc
	! cmp al, 15
	! ja NotNearJcc


	!'ooooooooooooooooooooooooooooooooo
	'  Conditional Near Jump Instructions
	!'ooooooooooooooooooooooooooooooooo

	mn = "J"
	tt = cb1 And 15
	fa = %Condition
	dt = %Rel8
	GoTo OpcodeDone

NotNearJcc:

	!'ooooooooooooooooooooooooooooooooo
	'   Prefixes
	!'ooooooooooooooooooooooooooooooooo

	! movzx eax, cb1
	! bt PrefixBits, eax
	! jnc NoPrefixBit
	'! mov eax, sp      ! mov ecx, cb1       ! bt [eax], ecx     ! jnb short NoHighBit       ! mov i,    NoHighBit:

PrefixHandler:

	'26 00100110 ES:
	'2E 00101110 CS:    or HINTNOTTAKEN?
	'36 00110110 SS:
	'3E 00111110 DS:    or HINTTAKEN?
	'64 01100100 FS:
	'65 01100101 GS:
	'66 01100110 OperandSize:
	'67 01100111 AddressSize:
	'9B 10011011 WAIT/FWAIT FPU (ESC)
	'F0 11110000 LOCK
	'F2 11110010 REPNE
	'F3 11110011 REP/REPE

	If (cb1 = &H66) And (cb2 = &H0F) Then 'SIMD

		Incr n
#Include "E:\PBWin7\Asm\DisAsm\DisAsm\Esc66.inc"

	ElseIf ((cb1 = &HF2) Or (cb1 = &HF3)) And (cb2 = &H0F) Then 'SIMD
		Incr n
#Include "E:\PBWin7\Asm\DisAsm\DisAsm\EscF2F3.inc"

	Else
		ItsaPrefix:

		pf = 0  'disable print out
		Incr pc 'maintain a count of prefixes

		p = InStr($Override, Chr$(cb1))
		If p Then pr = pr & Mid$("ECSDFG", p, 1) & "S: " : Exit If

		p = InStr($Prefix, Chr$(cb1))
		If p Then pr = pr & Choose$(p, "WAIT","LOCK","REPNE","REPE") & ": " : Exit If

		'it can only be &H66 or &H67 at this point
		If cb1 = &H66 Then oz = 1 Else az = 1

	End If

	Iterate Do


!'ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
'   The Rest of the Opcodes
!'ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo

NoPrefixBit:

	Select Case cb1

		Case <= &H1F
			mn = Mid$("PUSHPOP", ((cb1 And 1) * 4) + 1, 4) & " "
			mn = mn & Mid$("ESCSSSDS", (((cb1\8) And 3) * 2) + 1, 2)

		Case <= &H3F
			mn = Mid$("DAADASAAAAAS", (((cb1\8) And 3) * 3) + 1, 3)

		Case <= &H5F
			mn = Mid$("INC DEC PUSHPOP", (((cb1\8) And 3) * 4) + 1, 4)
			dt = %Reg : de = cb1 And 7 : wr = 1

		Case <= &H61    'PUSHA/PUSHAD   POPA/POPAD
			mn = Choose$(cb1 - &H5F, "PUSHA", "POPA")
			If oz = 0 Then mn = mn & "D"

		Case &H62   'BOUND r16,m16&16 / BOUND r32,m32&32
			mn = "BOUND" : dt = %Reg : de = rr
			st = %RegMem : sr = rm : wr = 1

			'0110 0010 : modregr/m

		Case &H63   'ARPL r/m16,r16
			mn = "ARPL" : st = %Reg : sr = rr
			dt = %RegMem : de = rm : oz = 1 : wr = 1

		Case &H68, &H6A     'PUSH imm32/16
			mn = "PUSH" : st = %Imm8_32 : If (cb1 And 2) = 0 Then wr = 1

		Case <= &H6B    '(&H69 and &H6B)    IMUL
			mn = "IMUL "
			GoSub DecodeReg32
			mn = mn & ", "
			GoSub DecodeRegMem
			If (cb1 And 2) = 0 Then wr = 1

			'reg1 with imm to reg2  0110 10s1 : 11 reg1 reg2 : immediate data
			'mem with imm to reg    0110 10s1 : mod reg r/m  : immediate data

		Case <= &H6D         'INSB / INSD / INSW
			mn = "INSB"
			If (cb1 And 1) Then Mid$(mn, 4, 1) = IIf$(oz, "W", "D")

		Case <= &H6F    'OUTSB / OUTSD / OUTSW
			mn = "OUTSB"
			If (cb1 And 1) Then Mid$(mn, 5, 1) = IIf$(oz, "W", "D")

		Case &H82   'undefined
			mn = "???"

		Case <= &H83    'Case &H80 to &H83 except for &H82
			'these support operand size mismatches
			mn = Mid$($Mn80, (rr * 3) + 1, 3)
			dt = %RegMem : de = rm : wr = (cb1 And 1)
			st = IIf&((cb1 And 2), %Imm8, %Imm8_32)

		Case &H84 To &H85    'TEST
			mn = "TEST"
			st = %Reg : sr = rr
			dt = %RegMem : de = rm
			wr = (cb1 And 1)
			'84 /r ; "TEST" r/m,r

		Case <= &H87    'XCHG r/m8-32,r8-32   r8-32,r/m8-32
			mn = "XCHG"
			dt = %Reg : de = rr
			st = %RegMem : sr = rm
			wr = (cb1 And 1)

		Case <= &H8B    'Case &H88 To &H8B    'MOV
			mn = "MOV"
			dt = %Reg : de = rr
			st = %RegMem : sr = rm
			wr = (cb1 And 1)
			If (cb1 And 2) = 0 Then Swap st, dt : Swap sr, de

		Case &H8D         'LEA r16,m / LEA r32,m
			mn = "LEA"
			dt = %Reg : de = rr
			st = %RegMem : sr = rm : wr = 1

		Case <= &H8E    '&H8C, &H8E     MOV Sreg,r/m16
			mn = "MOV"
			dt = %SegReg : de = rr
			st = %RegMem : sr = rm
			wr = (cb1 And 1)
			If (cb1 And 2) = 0 Then Swap st, dt : Swap sr, de

		Case &H8F         'POP m16 / POP m32
			mn = "POP" : dt = %RegMem : wr = 1

		Case &H90         'NOP
			mn = IIf$(pr = "REP:", "PAUSE", "NOP")
			'if preceded by "REP:", NOP is a "PAUSE" instruction

		Case <= &H97    'Case &H91 To &H97    XCHG EAX, Reg
			mn = "XCHG " : dt = %Reg : de = 0
			wr = 1 : st = %Reg : sr = cb1 And 7

		Case &H98         'CBW AX  / CWDE EAX
			mn = IIf$(oz, "CBW AX", "CWDE EAX")

		Case &H99         'CDQ EDX:EAX / CWD DX:AX
			mn = IIf$(oz, "CWD DX:AX", "CDQ EDX:EAX")

		Case &H9A         'CALL ptr16:16 / CALL ptr16:32
			mn = "CALL" : dt = %Ptr16_32

		Case <= &H9D    'PUSHF / PUSHFD     'POPF / POPFD
			mn = Choose$(cb1 - &H9B, "PUSHF", "POPF")
			If oz = 0 Then mn = mn & "D"

		Case <= &H9F    'SAHF   'LAHF
			mn = Mid$("SL", cb1 - &H9D, 1) & "AHF"

		Case &HA0 To &HA3    'MOV AL,moffs8 / MOV moffs32,EAX
			mn = "MOV" : dt = %Reg : de = 0 : st = %Moffs
			wr = (cb1 And 1)
			If (cb1 And 2) Then Swap dt, st : Swap de, sr  'reverse direction

		Case <= &HA7 '&HA4 to &HA7  'MOVSB/MOVSD/MOVSW and CMPSB/CMPSD/CMPSW
			mn = Mid$("MOVCMP", IIf&((cb1 And 2), 1, 4), 3) & "SB"
			If (cb1 And 1) Then Mid$(mn, 5, 1) = Mid$("DW", oz + 1, 1)

		Case <= &HA9 '(&HA8 To &HA9)   TEST
			mn = "TEST" : dt = %Reg : de = 0 : st = %Imm8_32
			wr = (cb1 And 1)

			'A8 ib ; "TEST" AL,imm8
			'A9 id ; "TEST" EAX,imm32
			'A9 iw ; "TEST" AX,imm16

		Case <= &HAF  '(&HAA to &HAF) STOSB/STOSD/STOSW, LODSB/LODSD/LODSW and SCASB/SCASD/SCASW
			mn = Mid$("STOLODSCA", ((((cb1\2) And 3) - 1) * 3) + 1, 3) & "SB"
			If (cb1 And 1) Then Mid$(mn, 5, 1) = Mid$("DW", oz + 1, 1)

		Case <= &HBF    '(&HB0 To &HBF) MOV AL,imm8 through MOV EDI,imm32
			mn = "MOV"
			dt = %Reg : de = cb1 And 7 : st = %Imm8_32
			wr = (cb1 And 8)

			'imm to reg      1011 w reg : immediate data

		Case &HC2 To &HC3    'RET imm16 / RET
			 mn = "RET NEAR" : dp = 1
			 If (cb1 And 1) = 0 Then st = %Imm16
			'C2 iw ; "RET" imm16
			'C3 ; "RET"

		Case <= &HC5 '&HC4 To &HC5  'LES r16,m16:16 through LDS r32,m16:32
			mn = "L" & Mid$("ED", cb1 - &HC3, 1) & "S"
			dt = %Reg : de = rr : st = %RegMem : sr = rm

		Case &HC6 To &HC7   'MOV r/m8,imm8/MOV r/m32,imm32
			mn = "MOV"
			dt = %RegMem : de = rm : st = %Imm8_32
			wr = (cb1 And 1)

		Case &HC8   'ENTER imm16,0
			mn = "ENTER"
			dt = %Imm8_32 : wr = 1 : oz = 1 : st = %Imm8

			'1100 1000 : 16-bit displacement : 8-bit level (L)

		Case &HC9         'LEAVE
			mn = "LEAVE"

		Case <= &HCB         'RET imm16 / RET
			mn = "RET FAR" : dp = 1
			If (cb1 And 1) Then st = %Imm8_32 : wr = 1 : oz = 1

		Case <= &HCF    'Case &HCC To &HCF
			mn = Mid$("INT3INT INTOIRET", ((cb1 And 3) * 4) + 1, 4)
			If cb1 = &HCD Then
				st = %Imm8_32
			ElseIf (cb1 = &HCF) And (az = 0) Then
				mn = mn & "D"
			End If

			'CC ; "INT3"
			'CD ib ; "INT" imm8
			'CE ; "INTO"
			'CF ; "IRET"
			'CF ; "IRETD"

		Case <= &HD5
			mn = "AA" & Mid$("MD", cb1 - &HD3, 1)
			If cb2 <> 10 Then mn = mn & " " & Hex$(cb2,2)

			'&HD4   AAM / AAM ib (No mnemonic)
			'&HD5   AAD / AAD ib (No mnemonic)

		Case &HD6 'undefined
			mn = "???"

		Case &HD7   '"XLAT"
			mn = "XLAT"

		Case <= &HE2    'Case &HE0 To &HE3  'LOOPNE rel8/LOOPE rel8/LOOP rel8/JECXZ rel8
			mn = "LOOP" & Mid$("NE", (cb1 And 3) + 1)
			dt = %Rel8

		Case &HE3    'JECXZ rel8 (16/32)
			If oz = 0 Then mn = "E"
			mn = "J" & mn & "CXZ"
			dt = %Rel8
			!'does this accept an override?

		Case <= &HE7  'Case &HE4 To &HE7  IN AL/AX/EAX,imm8 OUT imm8,AL/AX/EAX
			If (cb1 And 2) Then
				mn = "OUT " & Hex$(cb2) & ", "
			Else
				mn = "IN "
				st = %Imm8
			End If
			mn = mn & Right$("EA", (cb1 And 1) + 2 - oz)
			mn = mn & Mid$("LX", (cb1 And 1) + 1, 1)

		Case &HE8   'CALL rel32 / CALL rel16
			mn = "CALL" : dt = %Rel32 'or %Rel1632 ??

		Case <= &HEB    'JMP rel32/rel16/ptr16:16/ptr16:32/ JMP rel8
			mn = "JMP"
			Select Case cb1
				Case &HE9
					dt = %Rel32
				Case &HEA
					dt = %Rel1632   'full displacement
				Case &HEB
					dt = %Rel8
			End Select
			'E9 cd ; "JMP" rel32        'E9 cw ; "JMP" rel16
			'EA cd ; "JMP" ptr16:16     'EA cp ; "JMP" ptr16:32
			'EB cb ; "JMP" rel8

		Case <= &HEF 'Case &HEC To &HEF 'IN AL/AX/EAX,DX   OUT DX,AL/AX/EAX
			mn = IIf$(oz, "", "E")
			mn = mn & Mid$("LX", (cb1 And 1) + 1, 1)
			If (cb1 And 2) Then
				mn = "OUT DX, " & mn
			Else
				mn = "IN " & mn & ", DX"
			End If

		Case &HF1 'undefined
			mn = "???"

		Case <= &HF5    '&HF4 to &HF5
			mn = Mid$("HLTCMC", ((cb1 - &HF4) * 3) + 1, 3)

		Case &HF6 To &HF7 'misc
		  'F6 /0 ib ; "TEST" r/m8,imm8
		  'F6 /2 ; "NOT" r/m8
		  'F6 /3 ; "NEG" r/m8
		  'F6 /4 ; "MUL" r/m8
		  'F6 /5 ; "IMUL" r/m8
		  'F6 /6 ; "DIV" r/m8
		  'F6 /7 ; "IDIV" r/m8

		  'F7 /0 id ; "TEST" r/m32,imm32
		  'F7 /0 iw ; "TEST" r/m16,imm16
		  'F7 /2 ; "NOT" r/m16
		  'F7 /2 ; "NOT" r/m32
		  'F7 /3 ; "NEG" r/m16
		  'F7 /3 ; "NEG" r/m32
		  'F7 /4 ; "MUL" r/m16
		  'F7 /4 ; "MUL" r/m32
		  'F7 /5 ; "IMUL" r/m16
		  'F7 /5 ; "IMUL" r/m32
		  'F7 /6 ; "DIV" r/m16
		  'F7 /6 ; "DIV" r/m32
		  'F7 /7 ; "IDIV" r/m16
		  'F7 /7 ; "IDIV" r/m32
			wr = (cb1 And 1)
			If rr <> 1 Then dt = %RegMem : de = rm  'if cb2 = 1, it's an invalid opcode
			If rr = 0 Then st = %Imm8_32       'if cb2 = 0, it's a "TEST" instruction
			mn = Mid$("TEST??? NOT NEG MUL IMULDIV IDIV", (rr * 4) + 1, 4)

		Case <= &HFD '&HF8 to &HFD
			mn = Mid$("CLCSTCCLISTICLDSTD", ((cb1 - &HF8) * 3) + 1, 3)

		Case <= &HFF '(&HFE To &HFF ) misc
			de = rm
			Select Case rr
				Case < 2
					wr = (cb1 And 1)
					mn = Mid$("INCDEC", (rr * 3) + 1, 3)
					dt = %RegMem

				Case < 7
					mn = Mid$("CALLJMP PUSH", (((rr\2) - 1) * 4) + 1, 4)
					dt = IIf&((rr And 1), %Ptr16_32, %RegMem)
					wr = 1

				Case Else 'undefined
					mn = "???"
			End Select

		Case Else '&H80-&H83, &HD6 and &HF1
			Incr db     ': If db > 3 Then Exit Select
			'MsgBox Format$(cb1) & " was not found"

	End Select


!'ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
'   Operand Decoders
!'ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo

OpcodeDone:

	'apply some flags
	If (fa And %Condition) Then
		'"O","NO","B","NB","Z","NZ","BE","A","S","NS","P","NP","L","GE","LE","G"
		mn = mn & Mid$("O NOB NBZ NZBEA S NSP NPL GELEG ", (tt * 2) + 1, 2)
	ElseIf wr Then
	'ElseIf (fa And %DirBit) Then
	End If

	If dt <> %Implied Then mn = mn & " "
	If dt => %m2byte Then de = rm

	'----------------------------------
	'decode the destination operand
	Select Case dt
		Case %Implied
		'Case %ToEax
		Case %EaxEdx
		'Case %Reg32
		'Case %M16M32
		Case %Reg
			'$R8And32 = "ALCLDLBLAHCHDHBHAXCXDXBXSPBPSIDI"
			If wr Then
				If oz = 0 Then mn = mn & "E"
				de = de + 8
			End If
			mn = mn & Mid$($R8And32, (de * 2) + 1, 2) '& ", "

		Case %RegMem
			GoSub DecodeRegMem

		'Case %R16M
		Case %Rel8
			! movsx eax, cb2
			! add eax, ba
			! add eax, ip
			! sub eax, pd
			! inc eax       'one for the opcode
			! inc eax       'and one for the address byte
			! mov h, eax
			ad = Hex$(h, IIf&(az, 4, 6)) : GoSub PrintAd    'ad = Hex$(h, IIf&(az, 4, 8)) : GoSub PrintAd
			mn = mn & "SHORT L" & ad 'mn = mn & "SHORT " & ad
			Incr n

		Case %Rel16
			az = IIf&(az, 2, 4)
			h = CvDwd(wf, ip + n)
			! movzx eax, az
			! add eax, ba
			! add eax, ip
			! sub eax, pd
			! inc eax       'one for the opcode
			! add eax, h
			! mov h, eax
			n = n + az
			ad = Hex$(h, IIf&(az = 2, 4, 8)) : GoSub PrintAd    'ad = Hex$(h, IIf&(az = 2, 4, 8)) : GoSub PrintAd
			mn = mn & "L" & ad    'mn = mn & ad

		Case %Rel32
			az = IIf&(az, 2, 4)
			h = CvDwd(wf, ip + n)
			! movzx eax, byte ptr az
			! add eax, ba
			! add eax, ip
			! sub eax, pd
			! inc eax        'one for the opcode
			! add eax, h
			! mov h, eax
			If cb1 = &H0F Then Incr h
			n = n + az
			ad = Hex$(h, IIf&(az = 2, 4, 6)) : GoSub PrintAd    'ad = Hex$(h, IIf&(az = 2, 4, 8)) : GoSub PrintAd
			mn = mn & "L" & ad    'mn = mn & ad

		Case %Ptr16_32
			mn = mn & Hex$(CvWrd(wf, ip + n - 1), 4) & " : "
			mn = mn & Hex$(CvDwd(wf, ip + n + 1), IIf&(az, 4, 8))
			n = n + IIf&(az, 2, 4)

		Case %Moffs
			If wr Then
				If oz = 0 Then mn = mn & "D"
				mn = mn & "WORD"
			Else
				mn = mn & " BYTE"
			End If
			mn = mn & " PTR ["
			mn = mn & Hex$(CvDwd(wf, ip + n), IIf(az, 4, 8)) & "]"
			n = n + IIf(az, 2, 4)

		Case %SegReg
			'"ES", "CS", "SS", "DS", "FS", "GS",
			mn = mn & Mid$("ECSDFG", de + 1, 1) & "S"
		Case %St0
			mn = mn & "ST" : Incr n
		Case %Sti
			mn = mn & "ST(" & Format$(de) & ")" : Incr n
		'Case %St0Sti
		Case %StiSt0
			mn = mn & "ST(" & Format$(de) & "), ST" : Incr n

		Case %m2byte
			os = "WORD"
			GoSub DecodeRegMem

		Case %m16int
			os = "INTEGER"
			GoSub DecodeRegMem

		Case %m32int
			os = "LONG"
			GoSub DecodeRegMem

		Case %m64int
			os = "QUAD"
			GoSub DecodeRegMem

		Case %m32fp
			os = "SINGLE"
			GoSub DecodeRegMem

		Case %m64fp
			os = "DOUBLE"
			GoSub DecodeRegMem

		Case %m80fp
			os = "EXT (TBYTE)"
			GoSub DecodeRegMem

		Case %m80bcd
			os = "BCD (TBYTE)"
			GoSub DecodeRegMem

		Case %m1428Byte
			os = "28BYTE"
			GoSub DecodeRegMem

		Case %m94108Byte
			os = "108BYTE"
			GoSub DecodeRegMem

		Case Else
			Incr db     ': If db > 3 Then Exit Select
			'MsgBox Format$(st) & " was not found"
	End Select


	If (dt) And (st) Then mn = mn & ","
	If st => %m2byte Then sr = rm

	'----------------------------------
	'decode the source operand
	'some of these will use "de" for passing values to local subs
	Select Case st
		Case %Implied
		'Case %ToEax
		'Case %EaxEdx
		'Case %Reg32
		'Case %M16M32
		Case %Reg
			mn = mn & " "
			If wr Then
				If oz = 0 Then mn = mn & "E"
				sr = sr + 8
			End If
			mn = mn & Mid$($R8And32, (sr * 2) + 1, 2)

		Case %RegMem
			mn = mn & " "
			de = sr : GoSub DecodeRegMem

		Case %Imm8_32   'imm8 or imm32
			If wr Then '16 or 32 bits
				mn = mn & IIf$(oz, " WORD ", " DWORD ")
				mn = mn & Hex$(CvDwd(wf, ip + n), IIf&(oz, 4, 8))
				n = n + IIf&(oz, 2, 4)

			Else '8 biwf
				mn = mn & " BYTE " & Hex$(Asc(wf, ip + n), 2)
				Incr n
			End If

		Case %Imm8
			mn = mn & " BYTE " & Hex$(Asc(wf, ip + n), 2)
			Incr n

		Case %Imm16
			mn = mn & " " & Hex$(Asc(wf, ip + n), 4)
			n = n + 2

		Case %Imm16Imm8
		'Case %Imm16
		'    mn = mn & " " & Hex$(CvWrd(wf, ip + n), 4)
		'    n = n + 2
		'Case %Imm32
		'    mn = mn & " " & Hex$(CvDwd(wf, ip + n), 8)
		'    n = n + 4
		Case %Imm16Imm8
		Case %R16M
		'Case %Rel8
		'Case %Rel16
		'Case %Ptr16_32
		Case %Moffs
			If wr Then
				If oz = 0 Then mn = mn & "D"
				mn = mn & "WORD"
			Else
				mn = mn & " BYTE"
			End If
			mn = mn & " PTR ["
			mn = mn & Hex$(CvDwd(wf, ip + n), IIf(az, 4, 8)) & "]"
			n = n + IIf(az, 2, 4)
		'Case %Moffs32Eax
		Case %SegReg
			mn = mn & " " & Mid$("ECSDFG", de + 1, 1) & "S"
		Case %ByCL
			mn = mn & " CL"
		Case %ByOne
			mn = mn & " 1"
		Case %St0
			mn = mn & ", ST" : Incr n
		Case %Sti
			mn = mn & ", ST(" & Format$(sr) & ")" : Incr n
		Case %St0Sti
			mn = mn & "ST, ST(" & Format$(sr) & ")" : Incr n
		'Case %StiSt0
		'Case %AX
		'    mn = mn & ", AX"
			'mn = mn & "AX"

		Case %m2byte
			os = " WORD"
			de = sr : GoSub DecodeRegMem

		Case %m16int
			os = " INTEGER"
			de = sr : GoSub DecodeRegMem

		Case %m32int
			os = " LONG"
			de = sr : GoSub DecodeRegMem

		Case %m64int
			os = " QUAD"
			de = sr : GoSub DecodeRegMem

		Case %m32fp
			os = " SINGLE"
			de = sr : GoSub DecodeRegMem

		Case %m64fp
			os = " DOUBLE"
			de = sr : GoSub DecodeRegMem

		Case %m80fp
			os = " EXT (TBYTE)"
			de = sr : GoSub DecodeRegMem

		Case %m80bcd
			os = " BCD (TBYTE)"
			de = sr : GoSub DecodeRegMem

		Case %m1428Byte
			os = " 28BYTE"
			de = sr : GoSub DecodeRegMem

		Case %m94108Byte
			os = " 108BYTE"
			de = sr : GoSub DecodeRegMem

		Case Else
			Incr db ': If db > 3 Then Exit Select
			'MsgBox Format$(st) & " was not found"
	End Select

ClearPrefixes:
	az = 0 : oz = 0

	Loop Until ip > pe 'Len(wf)

	'Close# fo, ft

	'Function = ip

End Function 'DisAsm1

'<O><O><O><O><O><O><O><O><O><O><O><O><O><O><O><O>
