
'
%SIZEOF_FILE_HEADER 	 = 20
'Originally prefixed by "IMAGE_FILE_"
%RELOCS_STRIPPED		 = &H0001  ' Relocation info stripped from file.
%EXECUTABLE_IMAGE		 = &H0002  ' File is executable  (i.e. no unresolved externel references).
%LINE_NUMS_STRIPPED 	 = &H0004  ' Line nunbers stripped from file.
%LOCAL_SYMS_STRIPPED	 = &H0008  ' Local symbols stripped from file.
%AGGRESIVE_WS_TRIM		 = &H0010  ' Agressively trim working set
%LARGE_ADDRESS_AWARE	 = &H0020  ' App can handle >2gb addresses
%BYTES_REVERSED_LO		 = &H0080  ' Bytes of machine word are reversed.
%MACHINE32BIT			 = &H0100  ' 32 bit word machine.
%DEBUG_STRIPPED 		 = &H0200  ' Debugging info stripped from file in .DBG file
%REMOVABLE_RUN_FROM_SWAP = &H0400  ' If Image is on removable media, copy and run from the swap file.
%NET_RUN_FROM_SWAP		 = &H0800  ' If Image is on Net, copy and run from the swap file.
%SYSTEMFILE 			 = &H1000  ' System File.
%ISDLL					 = &H2000  ' File is a DLL.
%UP_SYSTEM_ONLY 		 = &H4000  ' File should only be run on a UP machine
%BYTES_REVERSED_HI		 = &H8000  ' Bytes of machine word are reversed.
%MACHINE_UNKNOWN		 = 0
%MACHINE_I386			 = &H014c  ' Intel 386.
%MACHINE_R3000			 = &H0162  ' MIPS little-endian, 0x160 big-endian
%MACHINE_R4000			 = &H0166  ' MIPS little-endian
%MACHINE_R10000 		 = &H0168  ' MIPS little-endian
%MACHINE_WCEMIPSV2		 = &H0169  ' MIPS little-endian WCE v2
%MACHINE_ALPHA			 = &H0184  ' Alpha_AXP
%MACHINE_POWERPC		 = &H01F0  ' IBM PowerPC Little-Endian
%MACHINE_SH3			 = &H01a2  ' SH3 little-endian
%MACHINE_SH3E			 = &H01a4  ' SH3E little-endian
%MACHINE_SH4			 = &H01a6  ' SH4 little-endian
%MACHINE_ARM			 = &H01c0  ' ARM Little-Endian
%MACHINE_THUMB			 = &H01c2
%MACHINE_IA64			 = &H0200  ' Intel 64
%MACHINE_MIPS16 		 = &H0266  ' MIPS
%MACHINE_MIPSFPU		 = &H0366  ' MIPS
%MACHINE_MIPSFPU16		 = &H0466  ' MIPS
%MACHINE_ALPHA64		 = &H0284  ' ALPHA64
%MACHINE_AXP64			 = %MACHINE_ALPHA64

'

Type DosHeader Byte 		'DOS stub in EXE file
	magic		As Word 	'Magic number
	cblp		As Word 	'Bytes on last page of file
	cp			As Word 	'Pages in file
	crlc		As Word 	'Relocations
	cparhdr 	As Word 	'Size of header in paragraphs
	minalloc	As Word 	'Minimum extra paragraphs needed
	maxalloc	As Word 	'Maximum extra paragraphs needed
	ss			As Word 	'Initial (relative) SS value
	sp			As Word 	'Initial SP value
	csum		As Word 	'Checksum
	ip			As Word 	'Initial IP value
	cs			As Word 	'Initial (relative) CS value
	lfarlc		As Word 	'File address of relocation table
	ovno		As Word 	'Overlay number
	res4		As Asciz * 8 '4 Reserved words
	oemid		As Word 	'OEM identifier (for oeminfo)
	oeminfo 	As Word 	'OEM information oemid specific
	res10		As Asciz * 20 '10 Reserved words
	lfanew		As Long  'always at &H3C and contains the offset of PE signature

End Type 'DosHeader

'

Type PEHeader Byte	'officially "IMAGEFILEHEADER"
	Machine 				As Word  'machine type
	NumberOfSections		As Word
	TimeDateStamp			As Dword 'Number of seconds since December 31st, 1969, at 4:00 P.M
	PointerToSymbolTable	As Dword
	NumberOfSymbols 		As Dword
	SizeOfOptionalHeader	As Word
	Characteristics 		As Word
End Type 'PEHeader

'

Type DataDir			Byte	'IMAGE_DATA_DIRECTORY
	RVA 				As Dword
	DirSize 			As Dword
End Type 'DataDir

'

%NumberOfDirectoryEntries = 16 'IMAGE_NUMBEROF_DIRECTORY_ENTRIES
'Optional header format ("IMAGE_OPTIONAL_HEADER32").
'this is not as "optional" as its name suggests
Type OptHeader			Byte
	'Standard fields.
	Magic				As Word  '"Magic number": &H10B = PE32, &H20B = PE32+, &H107 = ROM image
	MajLinkerVer		As Byte
	MinLinkerVer		As Byte
	SizeOfCode			As Dword
	SizeOfInitData		As Dword
	SizeOfUninitData	As Dword
	AddrOfEntryPoint	As Dword
	BaseOfCode			As Dword
	BaseOfData			As Dword

	'NT additional fields.
	ImageBase			As Dword 'defaults: DLL = &H10000000, EXE = &H400000
	SectionAlign		As Dword 'must be => file alignment
	FileAlign			As Dword 'alignment of raw data of sections. value should be a power of 2, => 512 and <= 64K ( default = 512)
	MajOSVer			As Word
	MinOSVer			As Word
	MajImageVer 		As Word
	MinImageVer 		As Word
	MajSubsysVer		As Word
	MinSubsysVer		As Word
	Win32VerValue		As Dword
	SizeOfImage 		As Dword 'size of image, including headers. must be a multiple of SectionAlign
	SizeOfHeaders		As Dword 'size of: stub + PE Header + section headers rounded up to multiple of FileAlign
	CheckSum			As Dword
	Subsystem			As Word
	DllCharacteristics	As Word
	SizeOfStackReserve	As Dword
	SizeOfStackCommit	As Dword
	SizeOfHeapReserve	As Dword
	SizeOfHeapCommit	As Dword
	LoaderFlags 		As Dword 'obsolete
	NumberOfRvaAndSizes As Dword 'Number of data-directory entries in the remainder of Optional Header
	'DataDirectory( %NumberOfDirectoryEntries ) As DataDir

End Type 'OptionalHeader

'

'----------------------------------------------------------------------------------------------
'			Data-Directory Entries
'----------------------------------------------------------------------------------------------
'Offset Type				Description
'----------------------------------------------------------------------------------------------
' 96	Export				Table Export Table address And size.
'104	Import Table		Import Table address And Size
'112	Resource Table		Resource Table address And size.
'120	Exception Table 	Exception Table address And size.
'128	Certificate Table	Attribute Certificate Table address And size.
'136	Base Relocation Table Base Relocation Table address And size.
'144	Debug				Debug Data starting address and size.
'152	Architecture		Architecture-specific Data address and size.
'160	Global Ptr			Relative virtual address Of the value To be stored In the Global
'							Pointer register. Size Member Of this structure must be Set To 0.
'168	TLS Table			Thread Local Storage (TLS) Table address And size.
'176	Load Config Table	Load Configuration Table address And size.
'184	Bound Import		Bound Import Table address And size.
'192	IAT Import			Address Table address And size.
'200	Delay Import		Descriptor Address And Size Of the Delay Import Descriptor.
'208	COM+ Runtime Header COM+ Runtime Header address And Size
'216	Reserved
'----------------------------------------------------------------------------------------------

'
'	Typical Section Name Content Characteristics (not for PowerBASIC though)
' .arch   Alpha architecture information IMAGE_SCN_MEM_READ | IMAGE_SCN_CNT_INITIALIZED_DATA | IMAGE_SCN_ALIGN_8BYTES | IMAGE_SCN_MEM_DISCARDABLE
' .bss	  Uninitialized data IMAGE_SCN_CNT_UNINITIALIZED_DATA | IMAGE_SCN_MEM_READ | IMAGE_SCN_MEM_WRITE
' .data   Initialized data IMAGE_SCN_CNT_INITIALIZED_DATA | IMAGE_SCN_MEM_READ | IMAGE_SCN_MEM_WRITE
' .edata  Export tables IMAGE_SCN_CNT_INITIALIZED_DATA | IMAGE_SCN_MEM_READ
' .idata  Import tables IMAGE_SCN_CNT_INITIALIZED_DATA | IMAGE_SCN_MEM_READ | IMAGE_SCN_MEM_WRITE
' .pdata  Exception information IMAGE_SCN_CNT_INITIALIZED_DATA | IMAGE_SCN_MEM_READ
' .rdata  Read-only initialized data IMAGE_SCN_CNT_INITIALIZED_DATA | IMAGE_SCN_MEM_READ
' .reloc  Image relocations IMAGE_SCN_CNT_INITIALIZED_DATA | IMAGE_SCN_MEM_READ | IMAGE_SCN_MEM_DISCARDABLE
' .rsrc   Resource directory IMAGE_SCN_CNT_INITIALIZED_DATA | IMAGE_SCN_MEM_READ | IMAGE_SCN_MEM_WRITE
' .text   Executable code IMAGE_SCN_CNT_CODE | IMAGE_SCN_MEM_EXECUTE | IIMAGE_SCN_MEM_READ
' .tls	  Thread-local storage IMAGE_SCN_CNT_INITIALIZED_DATA | IMAGE_SCN_MEM_READ | IMAGE_SCN_MEM_WRITE
' .xdata  Exception information IMAGE_SCN_CNT_INITIALIZED_DATA | IMAGE_SCN_MEM_READ
'

'Section header format.
%SizeOfShortName = 8
'Borland calls its code sections "CODE", rather than ".text".
Type SectionHeader		Byte	 ' _IMAGE_SECTION_HEADER
	SectName			As String * %SizeOfShortName
	VirtSize			As Dword
	RVA 				As Dword
	SizeOfRawData		As Dword
	PtrToRawData		As Dword
	PtrToRelocations	As Dword
	PtrToLineNums		As Dword
	NumberOfRelocations As Word
	NumberOfLineNums	As Word
	Characteristics 	As Dword
End Type 'SectionHeader

%SectionHeaderSize = 40 '%IMAGE_SIZEOF_SECTION_HEADER

'

' Export Format
Type ExportDir			Byte	' _IMAGE_EXPORT_DIRECTORY
	Characteristics 	As Dword 'for DLL
	TimeDateStamp		As Dword
	MajVersion			As Word
	MinVersion			As Word
	ExpName 			As Dword
	OrdBase 			As Dword 'ordinal base
	NumberOfFuncts		As Dword
	NumberOfNames		As Dword
	AddrOfFuncts		As Dword
	AddrOfNames 		As Dword
	AddrOfNameOrds		As Dword
End Type 'ExportDir

'

' Import Format
Type ImportByName		Byte ' _IMAGE_IMPORT_BY_NAME
	Hint				As Word
	ImpName 			As Byte
End Type 'ImportByName	IMAGE_IMPORT_BY_NAME

'

Type IMAGE_IMPORT_DESCRIPTOR
	Characteristics As Dword 'pointer to array of pointers to IMAGE_IMPORT_BY_NAME structures
	TimeDateStamp	As Dword
	ForwarderChain	As Dword
	ImportName		As Asciz Ptr
	FirstThunk		As Dword 'as PIMAGE_THUNK_DATA
End Type


'
