'
'   "PeEdit.inc"

' So far it only gets information from
'files.
'

'
' translates "Characteristics" property in section header
Function ReadSectionFlags(flgs As Long) As Long
#Register All

    s = s & "Flags: "
    If (flgs And &H00000020) Then s = s & "Code  "
    If (flgs And &H00000040) Then s = s & "Init-data  "
    If (flgs And &H00000080) Then s = s & "Uninit-data  "
    If (flgs And &H00000200) Then s = s & "Remarks "
    If (flgs And &H00000800) Then s = s & "Not-for-final  "
    If (flgs And &H02000000) Then s = s & "Discardable  "
    If (flgs And &H10000000) Then s = s & "Shareable  "
    If (flgs And &H20000000) Then s = s & "Executable  "
    If (flgs And &H40000000) Then s = s & "Readable  "
    If (flgs And &H80000000) Then s = s & "Writeable  "

    s = RTrim$(s) & $CrLf

End Function 'ReadSectionFlags

'
'read import table from ".link" section
'the end of the array is marked by an element
'filled with zeros
Function GetImports(    _
    wf As String,       _   'contains "whole file"
    ByVal pd As Dword,  _   'file offset to data
    ByVal de As Dword,  _   'value to subtract from ".link" offsets's
    ByVal ss As Dword,  _   'section size
    ByVal ba As Dword   _   'base address of process (not section)
    ) As Long

#Register All
Local fo    As Long
Local pa    As Dword 'array pointer
Local pi    As Dword 'ImportByname pointer
Local pt    As Dword 'pointer to import name address table
Local dn    As String
Local nm    As String
Local n     As Long
Local p     As Long

Local ic   As Long    'temporary import count
'dim   dl() as string  'DLL names with import counts
Dim   im(0) As String  'import names
Dim   ia(0) As Dword   'import jmp addresses

    's = s & $CrLf & "************* Imports *************" & $CrLf
    's = s & "The addresses are those used by API calls" & $CrLf

    fo = FreeFile
    Open $Imports  For Output As #fo

    For n = pd To pd + ss Step SizeOf(IMAGE_IMPORT_DESCRIPTOR)

        '------------------------------
        pa = CvDwd(wf, n + 12) 'get pointer to DLL's name
        If pa = 0 Then Exit For 'no more DLL names

        '------------------------------
        'get DLL name
        dn = Mid$(wf, pa - de + 1, 100) & $Nul
        dn = Left$(dn, InStr(dn, $Nul) - 1)
        p = InStr(dn, ".")
        If p Then dn = Left$(dn, p)

        'Print# fo, $Tab & $Tab & dn     's = s & $CrLf & $Tab & $Tab & dn & $CrLf & $CrLf

        '------------------------------
        '.Characteristics points to the array of ImportByName pointers
        pa = CvDwd(wf, n) - de + 1

        '.FirstThunk points to the import table
        pt = ba + CvDwd(wf, n + 16)

        '------------------------------
        Do

            pi = CvDwd(wf, pa)  'get pointer to import name

            '--------------------------
            'add 2 to point it past the hint. and then 1, since it's not zero-based
            If pi = 0 Then Exit Do Else pi = pi - de + 3 '+ 2 + 1

            '--------------------------
            'get import name
            nm = Mid$(wf, pi, 100) & $Nul : nm = Left$(nm, InStr(nm, $Nul) - 1)

            '--------------------------
            'collect the names and table addresses in arrays
            im(ic) = dn & "." & nm : ia(ic) = pt
            Incr ic : ReDim Preserve im(ic) : ReDim Preserve ia(ic)

            '--------------------------
            'append to result string
            Print# fo, Hex$(pt, 6) & $Tab & dn & nm 's = s & hex$(pt, 6) & "  " & nm & $CrLf

            '--------------------------
            'get ready for another one
            pa = pa + 4 : pt = pt + 4

        Loop

    Next n

    Close# fo

End Function 'GetImports

'
'read export table from ".link" section
'the end of the array is marked by an
'element filled with zeros
Function GetExports(    _
    wf As String,       _   'contains "whole file"
    ByVal pd As Dword,  _   'file offset to data
    ByVal de As Dword,  _   'value to subtract from ".link" offsets's
    ByVal ss As Dword,  _   'section size
    ca As Dword,        _   'value to subtract from ".text" offsets's
    ba As Dword         _   'base address
    ) As Long

#Register All
Local fo    As Long
Local pEd   As ExportDir Ptr
Local en    As String    'export name
Local n     As Long
Local af    As Dword Ptr 'to function address array
Local an    As Dword Ptr 'to name address array
Local ao    As Word Ptr  'to ordinal address array

    '----------------------------------
    'set up for the operation
    Function = 1 'preset to error value
    pEd = StrPtr(wf) + pd
    n = @pEd.NumberOfFuncts
    If n = 0 Then Exit Function

    fo = FreeFile
    Open $Exports For Output As #fo

    's = s & $CrLf & "************* Exports *************" & $CrLf & $CrLf

    '----------------------------------
    'point "af" to array of function addresses
    af = @pED.AddrOfFuncts - de + 1

    'point "an" to array of name pointers
    an = @pED.AddrOfNames - de + 1

    'point "ao" to array of ordinal addresses
    ao = @pED.AddrOfNameOrds - de + 1

    '----------------------------------
    'print# fo, "Offset:" & $Tab & "Export Name"  & $Tab & "Ordinal" & $CrLf
    's = s & "Offset:" & $Tab & "Export Name"  & $Tab & "Ordinal" & $CrLf & $CrLf
    For n = 1 To n

        'get name of function (assume none will be longer than 100
        en = Mid$(wf, CvDwd(wf, an) - de + 1, 101) & $Nul
        en = Left$(en, InStr(en, $Nul) - 1)

        'prepend address of function and some spacers
        en = Left$(Hex$(ba + CvDwd(wf, af), 6) & $Tab & en & String$(56, "."), 56)

        'append ordinal
        Mid$(en, 50) = Format$(CvWrd(wf, ao) + @pEd.OrdBase)

        'append export's data
        Print# fo, RTrim$(en, ".")  's = s & RTrim$(en, ".") & $CrLf

        'get ready for the next one
        af = af + 4 : an = an + 4 : ao = ao + 2

    Next n

    Close# fo

    Function = 0 'no error

End Function 'GetExports

'

Function DumpData(     _
    wf As String,      _   'contains "whole file"
    ByVal pd As Dword, _   'file offset to data
    ByVal ss As Dword, _   'section size
    ByVal ba As Dword  _   'base address
    ) As Long

#Register All
Local fo As Long
Local c  As Long  'character number
Local d  As Long  'data byte
Local n  As Long
Local t  As String


    fo = FreeFile
    Open $DataFile For Output As #fo

    's = s & $CrLf & "************* Data *************" & $CrLf & $CrLf

    For n = pd To pd + ss - 1 Step 16

        s = Hex$(ba + n - pd, 6) & "  " 's = s & Hex$(ba + n - pd, 8) & "  "
        t = Mid$(wf, n, 16)

        For c = 1 To 16
            d = Asc(t, c)
            s = s & Hex$(d, 2) & " "
            If c Mod 8 = 0 Then s = s & " "
            If (d < 32) Or (d > 126) Then Mid$(t, c) = "."
        Next c

        Print# fo, s & t    's = s & t & $CrLf

    Next n

    Close# fo

End Function 'DumpData

'

Function GetResources(  _
    wf As String,       _   'contains "whole file"
    ByVal pd As Dword,  _   'file offset to data
    ByVal de As Dword,  _   'value to subtract from ".link" offsets's
    ByVal ss As Dword   _   'section size
    ) As Long

    s = s & $CrLf & "************* Resources *************" & $CrLf & $CrLf

End Function 'GetResources

'

Function GetPeInfo(fs As String) As Long

#Register All
Local ra  As Dword  'RAM address of section
Local ff  As Long   'file handle
Local n   As Long
Local nm  As String 'Asciiz * %SizeOfShortName + 2
Local wf  As String '"whole file"

Local ca  As Dword 'adjustment for code offset
Local de  As Dword 'delta value to subtract from offsets
Local ep  As Dword 'file offset of entry point
Local pd  As Dword 'pointer to data
Local ss  As Dword 'section size

Local pDH As DosHeader Ptr
Local pPH As PEHeader Ptr
Local pOH As OptHeader Ptr
Local pSH As SectionHeader Ptr
Local pDD As DataDir Ptr

    '----------------------------------
    'get input file's contents
    Function = 1
    If Len(Dir$(fs)) = 0 Then Exit Function
    On Error GoTo AbortOp
    ff = FreeFile
    Open fs For Binary As #ff
    Get$ #ff, Lof(ff), wf
    Close# ff
    If Len(wf) < 400 Then
        AbortOp:
        Exit Function
    End If

    '----------------------------------
    'check for PE signature
    pDH = StrPtr(wf)
    pDH = pDH + @pDH.lfanew
    ! mov eax, pDH
    ! mov eax, [eax]
    ! mov n, eax
    If n <> &H04550 Then    '&H04550  = "PE" & $Nul & $Nul
        MsgBox "PE signature missing" : Exit Function
    End If
    pPH = pDH + 4

    '----------------------------------
    'open a file to send output to
    ff = FreeFile
    Open $Project For Output As #ff

    Print# ff, ""
    Print# ff, " Listing for: "
    Print# ff, fs
    Print# ff, ""
    Print# ff, ""

    '----------------------------------
    '"optional" header
    pOH = pPH + SizeOf(PEHeader)
    s = "Size of code = &H" & Hex$(@pOH.SizeOfCode) & $CrLf

    '@pOH.SizeOfInitData
    '@pOH.SizeOfUninitData
    s = s & "Base of code = &H" & Hex$(@pOH.BaseOfCode) & $CrLf
    s = s & "Base of data = &H" & Hex$(@pOH.BaseOfData) & $CrLf

    'NT additional fields.
    s = s & "Image base = &H" & Hex$(@pOH.ImageBase) & $CrLf 'base address in RAM
    s = s & "Section align = &H" & Hex$(@pOH.SectionAlign) & $CrLf
    s = s & "File align = &H" & Hex$(@pOH.FileAlign) & $CrLf

    '@pOH.FileAlign
    '@pOH.SizeOfImage
    '@pOH.SizeOfHeaders
    '@pOH.DllCharacteristics
    '@pOH.SizeOfStackReserve
    '@pOH.SizeOfStackCommit
    '@pOH.SizeOfHeapReserve
    '@pOH.SizeOfHeapCommit
    '@pOH.LoaderFlags
    '@pOH.NumberOfRvaAndSizes

    '----------------------------------
    'dump section table
    Data Export Table, Import Table, Resource Table, Exception Table
    Data Certificate Table, Base Relocation Table, Debug data
    Data Architecture-specific data, Global Ptr, Thread Local Storage
    Data Load Configuration Table, Bound Import Table, Import Address Table
    Data Delay Import Descriptor, COM+ Runtime Header, Reserved

    Print# ff, "************* Section Table *************"
    Print# ff, "Rva:   Size:   Type:"

    n = 0
    Local lm As Long, st As Long
    Dim rva(1 To 16) As Local Dword
    Dim ssz(1 To 16) As Local Dword
    pDD = pOH + SizeOf(OptHeader)
    st = SizeOf(DataDir)
    lm = pDD + ((@pOH.NumberOfRvaAndSizes - 1) * st)

    For pDD = pDD To lm Step st
        Incr n
        rva(n) = @pDD.RVA
        ssz(n) = @pDD.DirSize
        If rva(n) Then Print# ff, Hex$(rva(n), 8) & $Tab & Hex$(ssz(n), 6) & $Tab & Read$(n)
    Next pDD

    Print# ff, ""
    Print# ff, s
    Print# ff, ""

    '----------------------------------
    'get data from the sections
    pSH = pOH + SizeOf(OptHeader) + (@pOH.NumberOfRvaAndSizes * SizeOf(DataDir))
    For n = 1 To @pPH.NumberOfSections

        'get section name
        nm = Peek$(pSH, %SizeOfShortName) & $Nul
        nm = Left$(nm, InStr(nm, $Nul) - 1)
        s = "Section: " & $Dq & nm & $Dq & $CrLf

        ReadSectionFlags @pSH.Characteristics
        Print# ff, s

        pd = @pSH.PtrToRawData + 1 'get section's position in string

        'get value to subtract from RVAs to get file offsets
        de = (@pSH.RVA - @pSH.PtrToRawData)

        ra = @pOH.ImageBase + @pSH.RVA 'section's RAM address

        'section names from other files:
        'LCOD, RARE, PNP DOSVp, PCOD, PDATP, ICOD
        Select Case LCase$(nm)

            'this contains the executable code (yes, ".text" is an odd name for it)
            Case ".text"    ', "code", ".code", "lcod"
                ca = de
                ep = @pOH.AddrOfEntryPoint
                Print# ff, "Address of program entry point = &H" & Hex$(@pOH.ImageBase + ep) & $CrLf
                s = "" : ep = ep - de + 1 'ep = position of entry point in string

                DisAsm(wf, pd, pd + @pSH.SizeOfRawData, ra, ep) ', ff)

            Case ".data"    ', ".rdata"    'this contains the data
                DumpData(wf, pd, @pSH.SizeOfRawData, ra)

            Case ".link"    ', ".idata"    'this contains the imports and exports
                GetImports(wf, pd, de, @pSH.SizeOfRawData, @pOH.ImageBase)

                If rva(%Export) Then
                    pd = rva(%Export) - de
                    GetExports(wf, pd, de, ssz(%Export), ca, @pOH.ImageBase)
                Else
                    If Len(Dir$($Exports)) Then Kill $Exports
                End If

            Case ".rloc"    ', ".reloc"    'this contains the relocations
                pd = rva(%BaseReloc) - de + 1

            Case ".rsrc"    'this contains the resources
                pd = rva(%Resource) - de + 1
                'GetResources(wf, pd, de, ssz(%Resource), ra)

            Case Else
                Exit For

        End Select

        pSH = pSH + SizeOf(SectionHeader) 'advance pSH to next section header

    Next n

    Close #ff

    Function = 0

End Function 'GetPeInfo

'
